#!/bin/bash
#20200701 webber
#set -xv
#執行檔

##################自訂參數###################
#worker空閒數量
worker=5
#收件信箱
mailto="support@twnoc.net"
#偵測間隔
time1=60
#二次判斷間隔
time2=30
############################################

##################固定參數###################
hostname1=$(hostname)
mails=${hostname1}" - apache_restart"
re=0
today=$(date -d"$(date)" +%Y%m%d)
#############################################

#日期重置判斷
datarr() {
	today1=$(date -d"$(date)" +%Y%m%d)
	if [ ${today1} != ${today} ]; then
		re=0
		today=${today1}
	fi
}

doit() {
	#抓取workers的閒置數 設定為workers1
	workers1=$(/usr/bin/lynx -dump -width 500 http://127.0.0.1/whm-server-status | grep 'idle workers' | awk '{print $6 }')

	if [[ -z ${workers1} ]]; then

		sleep ${time2}

		workers2=$(/usr/bin/lynx -dump -width 500 http://127.0.0.1/whm-server-status | grep 'idle workers' | awk '{print $6 }')

		if [[ -z ${workers2} ]]; then

			service httpd stop >/dev/null
			service httpd start >/dev/null
			re=$(($re + 1))
			echo " " >apachelog.txt
			sed -i "1i\今日重啟次數${re}次" apachelog.txt
			sed -i '1 a/ 偵測不到apache服務' apachelog.txt
			mail -s "${mails}" ${mailto} <apachelog.txt
		fi

	else

		if [[ ${workers1} -le 5 ]]; then

			sleep ${time2}

			workers2=$(/usr/bin/lynx -dump -width 500 http://127.0.0.1/whm-server-status | grep 'idle workers' | awk '{print $6 }')

			if [[ ${workers2} -le 5 ]]; then
				curl 127.0.0.1/whm-server-status | grep '<td nowrap>' | awk -F'>' '{print $7}' | grep -v '^<' | sort | uniq -c | sort -n | cut -d : -f 1 >apachelog.txt
				service httpd stop >/dev/null
				service httpd start >/dev/null
				re=$(($re + 1))
				sed -i "1i\今日重啟次數${re}次" apachelog.txt
				mail -s "${mails}" ${mailto} <apachelog.txt
			fi
		fi
	fi
}

#  執行

while true; do
	datarr >/dev/null
	doit >/dev/null
	sleep ${time1}
done

